Index: /trunk/prototype/modules/calendar/interceptors/DBMapping.php
===================================================================
--- /trunk/prototype/modules/calendar/interceptors/DBMapping.php	(revision 5715)
+++ /trunk/prototype/modules/calendar/interceptors/DBMapping.php	(revision 5723)
@@ -319,5 +319,5 @@
        $u = $result->format('U') * 1000;
 
-       if( $u  > $end ) //data da repetição atual maior que a data final da busca do usuario ?
+       if( $u  > $end ) //data da repetiÃ§Ã£o atual maior que a data final da busca do usuario ?
            break;
 
@@ -493,6 +493,6 @@
 				$result[$i]['DayLigth'] = $DayLigth;
 				
-                if(isset($v['id']))
-                {
+		if(isset($v['id']))
+		{
                     $participants = Controller::find( array( 'concept' => 'participant' ) , false ,array( 'filter' => array('=', 'schedulable'  ,  $v['id']) )); 
                     
@@ -522,13 +522,9 @@
 		    }
 
-		    if(isset($result[$i]['repeat'])){
-		      $repeat = Controller::read( array( 'concept' => 'repeat', 'id' => $result[$i]['repeat'] ) );
-
-		      if( !is_array($repeat) )
-			  unset( $result[$i]['repeat'] );
-		      else
-			  $result[$i]['repeat'] = $repeat[0];
-		    }
-	    }               
+		    $repeat = Controller::find( array( 'concept' => 'repeat' ), false, array( 'filter' => array( '=', 'schedulable', $v['id'] ) ) );
+
+		    if( is_array($repeat) )
+			$result[$i]['repeat'] = $repeat[0];
+		}
                 
            }
@@ -620,5 +616,5 @@
                     $result[$i]['calendar'] = Controller::read( array( 'concept' => 'calendar' , 'id' => $v['calendar']), false, false); 
 					$result[$i]['defaultAlarms'] = Controller::find( array( 'concept' => 'calendarSignatureAlarm' ) , false ,array( 'filter' => array('=', 'calendarSignature'  ,  $v['id']) ));    
-					//Caso nÃ£o seja o dono da agenda retorna o objeto permission com as acls
+					//Caso nÃÂ£o seja o dono da agenda retorna o objeto permission com as acls
 					if($result[$i]['isOwner'] == 0){
 						$permission = Controller::find( array( 'concept' => 'calendarToPermission'), false ,array( 'filter' => array('AND', array('=', 'calendar' ,  $v['calendar']), array('=', 'user', Config::me('uidNumber') ) ) ) ); 
@@ -737,5 +733,5 @@
                      )));
             
-            return false; /* Mata o restante da execuÃ§Ã£o */
+            return false; /* Mata o restante da execuÃÂ§ÃÂ£o */
         } 
         
@@ -774,5 +770,5 @@
     public function createDefaultSignature( &$uri , &$result , &$criteria , $original ){
     		     
-    //Caso uma busca nÃ£o retorne nenhum resultado e foi buscado pelas assinaturas do usuario logado apenas
+    //Caso uma busca nÃÂ£o retorne nenhum resultado e foi buscado pelas assinaturas do usuario logado apenas
     if(count($result) <= 0 && 
             ( $original['criteria']['filter'][0] == '=' &&
@@ -825,7 +821,7 @@
         else
         {
-         //Criaremos uma agenda parÃ£o
+         //Criaremos uma agenda parÃÂ£o
           $cal = array('name' => 'Calendario',
-                         'description' => 'Calendario PadrÃ£o',
+                         'description' => 'Calendario PadrÃÂ£o',
                          'timezone' =>  (date_default_timezone_get()) ? date_default_timezone_get() : 'America/Sao_Paulo',
                          'dtstamp' => time().'000'
@@ -914,5 +910,5 @@
                     continue;
                 
-                //CriaÃ§Ã£o do ical
+                //CriaÃÂ§ÃÂ£o do ical
                 $ical = null;
               	$ical = new vcalendar();
@@ -935,5 +931,5 @@
 				///////////////////////////////////////////////////////////////////////////
                 
-                //CriaÃ§Ã£o do E-mail
+                //CriaÃÂ§ÃÂ£o do E-mail
                 $mail = array();
                 $mail['isHtml'] = true;  
@@ -952,6 +948,6 @@
                                                         ),ROOTPATH.'/api/templates/notify_create_body.tpl');
                 
-                //TODO: InternacionalizaÃ§Ã£o do Subject
-                $mail['subject'] = 'Schedulableo do CalendÃ¡rio : '.$schedulable['summary'] .' @ '.date_format( $sTime , 'd/m/Y H:i') . ' - ' .  date_format( $eTime , 'd/m/Y H:i');
+                //TODO: InternacionalizaÃÂ§ÃÂ£o do Subject
+                $mail['subject'] = 'Schedulableo do CalendÃÂ¡rio : '.$schedulable['summary'] .' @ '.date_format( $sTime , 'd/m/Y H:i') . ' - ' .  date_format( $eTime , 'd/m/Y H:i');
                 $mail['from'] =  $organizer['mail'];
                 $mail['to'] = $att[$i]['mail'];