Index: /trunk/prototype/modules/calendar/interceptors/DBMapping.php
===================================================================
--- /trunk/prototype/modules/calendar/interceptors/DBMapping.php	(revision 5727)
+++ /trunk/prototype/modules/calendar/interceptors/DBMapping.php	(revision 5729)
@@ -319,5 +319,5 @@
        $u = $result->format('U') * 1000;
 
-       if( $u  > $end ) //data da repetiÃ§Ã£o atual maior que a data final da busca do usuario ?
+       if( $u  > $end ) //data da repetição atual maior que a data final da busca do usuario ?
            break;
 
@@ -616,5 +616,5 @@
                     $result[$i]['calendar'] = Controller::read( array( 'concept' => 'calendar' , 'id' => $v['calendar']), false, false); 
 					$result[$i]['defaultAlarms'] = Controller::find( array( 'concept' => 'calendarSignatureAlarm' ) , false ,array( 'filter' => array('=', 'calendarSignature'  ,  $v['id']) ));    
-					//Caso nÃ£o seja o dono da agenda retorna o objeto permission com as acls
+					//Caso não seja o dono da agenda retorna o objeto permission com as acls
 					if($result[$i]['isOwner'] == 0){
 						$permission = Controller::find( array( 'concept' => 'calendarToPermission'), false ,array( 'filter' => array('AND', array('=', 'calendar' ,  $v['calendar']), array('=', 'user', Config::me('uidNumber') ) ) ) ); 
@@ -733,5 +733,5 @@
                      )));
             
-            return false; /* Mata o restante da execuÃ§Ã£o */
+            return false; /* Mata o restante da execução */
         } 
         
@@ -770,5 +770,5 @@
     public function createDefaultSignature( &$uri , &$result , &$criteria , $original ){
     		     
-    //Caso uma busca nÃ£o retorne nenhum resultado e foi buscado pelas assinaturas do usuario logado apenas
+    //Caso uma busca não retorne nenhum resultado e foi buscado pelas assinaturas do usuario logado apenas
     if(count($result) <= 0 && 
             ( $original['criteria']['filter'][0] == '=' &&
@@ -821,7 +821,7 @@
         else
         {
-         //Criaremos uma agenda padrÃ£o
+         //Criaremos uma agenda padrão
           $cal = array('name' => 'Calendario',
-                         'description' => 'Calendario PadrÃ£o',
+                         'description' => 'Calendario Padrão',
                          'timezone' =>  (date_default_timezone_get()) ? date_default_timezone_get() : 'America/Sao_Paulo',
                          'dtstamp' => time().'000'
@@ -910,5 +910,5 @@
                     continue;
                 
-                //CriaÃ§Ã£o do ical
+                //Criação do ical
                 $ical = null;
               	$ical = new vcalendar();
@@ -948,5 +948,5 @@
                                                         ),ROOTPATH.'/api/templates/notify_create_body.tpl');
                 
-                //TODO: InternacionalizaÃ§Ã£o do Subject
+                //TODO: Internacionalização do Subject
                 $mail['subject'] = 'Schedulableo do CalendÃÂ¡rio : '.$schedulable['summary'] .' @ '.date_format( $sTime , 'd/m/Y H:i') . ' - ' .  date_format( $eTime , 'd/m/Y H:i');
                 $mail['from'] =  $organizer['mail'];
Index: /trunk/prototype/modules/calendar/js/calendar.codecs.js
===================================================================
--- /trunk/prototype/modules/calendar/js/calendar.codecs.js	(revision 5724)
+++ /trunk/prototype/modules/calendar/js/calendar.codecs.js	(revision 5729)
@@ -198,12 +198,17 @@
 			this.addAlarm( eventsDay[i] );
 		}
-	},
-	
-	addAlarm: function( eventDay ){
+        },
+	
+	addAlarm: function( eventDay ){            
                 if(!DataLayer.tasks[parseInt(eventDay.sendTime)]){
                     DataLayer.task( parseInt(eventDay.sendTime) , function( timestamp ){
-                    	DataLayer.render('templates/alarm.ejs',{event: eventDay}, function( html ){
-				var dlgAlarm = jQuery('#div-alarm').html( html ).find('.alarm-event.active');
-				dlgAlarm.dialog({resizable: false, modal:true, width:400, minHeight: 100,position: 'center', close:function(){$(this).dialog('destroy');$(this).dialog('open');}});
+                        var path = User.moduleName == 'expressoCalendar' ? '' : '../prototype/modules/calendar/';
+                        DataLayer.render(path+'templates/alarm.ejs',{event: eventDay}, function( html ){                                
+                                $.Zebra_Dialog(html , {
+                                    'type':     'question',
+                                    'overlay_opacity': '0.5',
+                                    'buttons':  ['Fechar'],
+                                    'onClose':  function(clicked) {}
+                               });
 			});
                     });
@@ -611,5 +616,6 @@
 							receiveNotification : attend.receiveNotification,
 							alarms : $.map(attend.alarms || [], function( alarm ){
-								return DataLayer.get('alarm', alarm);
+								var alarm = DataLayer.get('alarm', alarm);
+                                                                return (alarm == "" ? (null) : alarm);
 							})
 						};
Index: /trunk/prototype/modules/calendar/templates/event_add.ejs
===================================================================
--- /trunk/prototype/modules/calendar/templates/event_add.ejs	(revision 5715)
+++ /trunk/prototype/modules/calendar/templates/event_add.ejs	(revision 5729)
@@ -124,7 +124,7 @@
 				<label>Avisar-me por </label>
 				<select name="alarmType[]">
-				<!--<option value="alert" <%= data.event.alarms[i].type=='alert' ? 'selected="selected"':'' %>>Alerta</option>
-					<option value="mail" <%= data.event.alarms[i].type=='mail' ? 'selected="selected"':'' %>>E-mail</option>-->
-					<option value="sms" <%= data.event.alarms[i].type=='sms' ? 'selected="selected"':'' %>>SMS</option>
+                                    <option value="alert" <%= data.event.alarms[i].type=='alert' ? 'selected="selected"':'' %>>Alerta</option>
+                                    <option value="mail" <%= data.event.alarms[i].type=='mail' ? 'selected="selected"':'' %>>E-mail</option>
+                                    <!--<option value="sms" <%= data.event.alarms[i].type=='sms' ? 'selected="selected"':'' %>>SMS</option>-->
 				</select>
 				<input type="text" name="alarmTime[]" class="number input-small" value="<%= data.event.alarms[i].time %>"/>
Index: /trunk/prototype/modules/calendar/templates/alarm.ejs
===================================================================
--- /trunk/prototype/modules/calendar/templates/alarm.ejs	(revision 5341)
+++ /trunk/prototype/modules/calendar/templates/alarm.ejs	(revision 5729)
@@ -3,5 +3,5 @@
 		<legend class="hidden">Alarme de Evento</legend>
 				<div class="new-event-alarm">
-					Você possui um compromisso agendado:
+                                    <b>Você possui um compromisso agendado:</b>
 				</div>
 				<div class="title-event-alarm">
@@ -21,6 +21,3 @@
 				</div>
     </fieldset>
-    <div class="menu-container footer-container">
-		<a class="button alarm-btn-fechar" href="#"></a>
-    </div>
  </div>
Index: /trunk/expressoMail1_2/index.php
===================================================================
--- /trunk/expressoMail1_2/index.php	(revision 5713)
+++ /trunk/expressoMail1_2/index.php	(revision 5729)
@@ -80,9 +80,17 @@
 		
 		<script type="text/javascript" src="../prototype/modules/calendar/js/timezone.js"></script>
-		
+                <script type="text/javascript" src="../prototype/plugins/dateFormat/dateFormat.js"></script>
+		<script type="text/javascript" src="../prototype/modules/calendar/js/calendar.date.js"></script>
 		<script type="text/javascript" src="../prototype/modules/calendar/js/calendar.codecs.js"></script>
 
 		<script src="js/rich_text_editor.js" type="text/javascript"></script>
-		<script src="js/base64.js" type="text/javascript"></script>';
+		<script src="js/base64.js" type="text/javascript"></script>
+                
+                <script type="text/javascript"> 
+                    User.moduleName = "expressoMail1_2";
+		</script> 
+
+
+                ';
 	//---------------------------//
 
Index: /trunk/expressoMail1_2/templates/default/expressoMail_reset.css
===================================================================
--- /trunk/expressoMail1_2/templates/default/expressoMail_reset.css	(revision 5642)
+++ /trunk/expressoMail1_2/templates/default/expressoMail_reset.css	(revision 5729)
@@ -135,12 +135,18 @@
 }
 
- #new_event_map .map-event .fc-event-inner.fc-event-skin .fc-event-head, #new_event_map .map-event .fc-event-inner.fc-event-skin .fc-event-content{
+#new_event_map .map-event .fc-event-inner.fc-event-skin .fc-event-head, #new_event_map .map-event .fc-event-inner.fc-event-skin .fc-event-content{
 	background-color: transparent !important;
 	color: transparent !important;
 }
 
- #new_event_map .map-event .ui-resizable-handle{
+#new_event_map .map-event .ui-resizable-handle{
 	display : block !important;
 	color: black !important;
+}
+
+fieldset.alarm{  
+    border: none !important;
+    padding: 0px !important;
+    margin: 0px !important;
 }
 
Index: /trunk/expressoMail1_2/js/main.js
===================================================================
--- /trunk/expressoMail1_2/js/main.js	(revision 5718)
+++ /trunk/expressoMail1_2/js/main.js	(revision 5729)
@@ -3270,5 +3270,5 @@
 		
 		//$.ajax({ url: "../expressoCalendar/index.php", async: false});
-		$.ajax({url: "../prototype/modules/calendar/js/calendar.date.js", async: false, beforeSend: function( xhr ) { xhr.overrideMimeType('text/javascript; charset=ISO-8859-1')}});
+		//$.ajax({url: "../prototype/modules/calendar/js/calendar.date.js", async: false, beforeSend: function( xhr ) { xhr.overrideMimeType('text/javascript; charset=ISO-8859-1')}});
 		$.ajax({url: "../prototype/modules/calendar/js/map.disponibility.js", async: false, beforeSend: function( xhr ) { xhr.overrideMimeType('text/javascript; charset=ISO-8859-1')}});
 		$.ajax({url: "../prototype/modules/calendar/js/helpers.js", async: false, beforeSend: function( xhr ) { xhr.overrideMimeType('text/javascript; charset=ISO-8859-1')}});
@@ -3276,5 +3276,5 @@
 		//$.ajax({ url: "../prototype/modules/calendar/js/calendar.codecs.js", async: false});
 		$.ajax({url: "../prototype/plugins/encoder/encoder.js", async: false, beforeSend: function( xhr ) { xhr.overrideMimeType('text/javascript; charset=ISO-8859-1')}});
-		$.ajax({url: "../prototype/plugins/dateFormat/dateFormat.js", async: false, beforeSend: function( xhr ) { xhr.overrideMimeType('text/javascript; charset=ISO-8859-1')}});
+		//$.ajax({url: "../prototype/plugins/dateFormat/dateFormat.js", async: false, beforeSend: function( xhr ) { xhr.overrideMimeType('text/javascript; charset=ISO-8859-1')}});
 
 		$.ajax({ url: "../prototype/plugins/fullcalendar/fullcalendar.js", async: false , beforeSend: function( xhr ) { xhr.overrideMimeType('text/javascript; charset=ISO-8859-1')}});