Index: /trunk/prototype/modules/mail/js/followupflag.js
===================================================================
--- /trunk/prototype/modules/mail/js/followupflag.js	(revision 5711)
+++ /trunk/prototype/modules/mail/js/followupflag.js	(revision 5738)
@@ -71,5 +71,4 @@
 						},
 						select: function( event, ui ) {
-							winElement.find('.menu-configure-followupflag .save').button("enable");
 							ui.item.option.selected = true;
 							self._trigger( "selected", event, {
@@ -333,4 +332,5 @@
 	winElement.find('.time').timepicker({});
 	winElement.find('[name="name"]').combobox();
+	winElement.find('.ui-corner-right.ui-button-icon').attr('title', get_lang('Show All Items'));
 
 	winElement.find('[name="alarmDate"],[name="alarmTime"]').attr("disabled","disabled");
@@ -416,5 +416,5 @@
 		{
 			attrDeadline: 'doneDeadline', 
-			caption: {singular:'Você tem uma mensagem concluindo hoje:', plural:"Você tem %1 mensagens concluindo hoje:"},
+			caption: {singular:'You have one undone message today:', plural:"You have %1 undone messages today:"},
 			onOk: function(event){
 				if($(event.target).parents('.doneDeadline').find('[name="stopAlert"]').is(':checked')){
@@ -426,5 +426,5 @@
 		{
 			attrDeadline: 'alarmDeadline',
-			caption: {singular:'Você tem uma mensagem sinalizada para hoje:', plural:'Você tem %1 mensagens sinalizadas para hoje:'},
+			caption: {singular:'You have a follow up due for today:', plural:'You have %1 follow ups due for today:'},
 			onOk: function(event){
 				if($(event.target).parents('.alarmDeadline').find('[name="stopAlert"]').is(':checked')){
Index: /trunk/prototype/modules/mail/templates/followupflag_configure.ejs
===================================================================
--- /trunk/prototype/modules/mail/templates/followupflag_configure.ejs	(revision 5676)
+++ /trunk/prototype/modules/mail/templates/followupflag_configure.ejs	(revision 5738)
@@ -2,5 +2,5 @@
 <%
 	if (data.messages.length == 1) {
-		var followupflagged = data.messages[0].followupflagged ? data.messages[0].followupflagged : followupflagged = { followupflag: {} };
+		var followupflagged = data.messages[0].followupflagged ? data.messages[0].followupflagged : { followupflag: {id: 1} };
 		if (followupflagged.doneDeadline)
 			followupflagged.doneDeadline = Date.parseExact(followupflagged.doneDeadline, 'yyyy-MM-dd hh:mm:ss');
@@ -10,5 +10,5 @@
 	} else if (data.messages.length > 1) {
 		var followupflagged = {
-			followupflag: {name: true},
+			followupflag: {name: true, id: 1},
 			isDone: true,
 			doneDeadline: true,
@@ -21,5 +21,5 @@
 		for(var i=0; i<data.messages.length; i++){
 			if (!data.messages[i].followupflagged) {
-				followupflagged = { followupflag: {} };
+				followupflagged = { followupflag: {name: false, id: false} };
 				break;
 			}
@@ -28,4 +28,7 @@
 			followupflagged.followupflag.name = (followupflagged.followupflag.name && data.messages[i].followupflagged.followupflag.name == data.messages[i-1].followupflagged.followupflag.name) ?
 				data.messages[i].followupflagged.followupflag.name : false;
+				
+			followupflagged.followupflag.id = (followupflagged.followupflag.id && data.messages[i].followupflagged.followupflag.id == data.messages[i-1].followupflagged.followupflag.id) ?
+				data.messages[i].followupflagged.followupflag.id : false;
 				
 			followupflagged.isDone = (followupflagged.isDone && data.messages[i].followupflagged.isDone == data.messages[i-1].followupflagged.isDone) ?
@@ -58,6 +61,8 @@
 			<select name="name">
 				<% for(var i=0; i<data.followupflags.length; i++) {  %>
-					<% var selected = (data.followupflags[i].name == followupflagged.followupflag.name  ) ? 'selected="selected"' : '' %> 
-					<option value="<%= data.followupflags[i].id %>" <%= selected %>><%= data.followupflags[i].name %></option>
+					<% var selected = (data.followupflags[i].id == followupflagged.followupflag.id ) ? 'selected="selected"' : '' %>
+					<% if(data.followupflags[i].id >= 1 && data.followupflags[i].id <= 6){ var innerOption = get_lang(data.followupflags[i].name)
+					}else{var innerOption = data.followupflags[i].name}%>
+					<option value="<%= data.followupflags[i].id %>" <%= selected %>><%= innerOption %></option>
 				<% } %>
 			</select>
Index: /trunk/prototype/modules/mail/templates/followupflag_alarm_list.ejs
===================================================================
--- /trunk/prototype/modules/mail/templates/followupflag_alarm_list.ejs	(revision 5705)
+++ /trunk/prototype/modules/mail/templates/followupflag_alarm_list.ejs	(revision 5738)
@@ -5,9 +5,13 @@
 for(var i=0; i<data.alarmInRange.length; i++){
 	var openMessageScript = "cExecute('$this.imap_functions.get_info_msg&msg_number="+data.alarmInRange[i].messageNumber+"&msg_folder="+data.alarmInRange[i].folderName+"&alarm=true', show_msg);";
-	
+	if(data.alarmInRange[i].followupflag.id < 7){
+		var nameFollowupflag = get_lang(data.alarmInRange[i].followupflag.name);
+	}else{
+		var nameFollowupflag = data.alarmInRange[i].followupflag.name;
+	}
 %>
 	<li class="message-item">
 		<a onclick="<%=openMessageScript%>">
-			<%= (it.attrDeadline == 'alarmDeadline') ? data.alarmInRange[i].alarmDeadline : data.alarmInRange[i].doneDeadline %> - <%= data.alarmInRange[i].followupflag.name %> - <%= data.alarmInRange[i].message.headers.subject %>
+			<%= (it.attrDeadline == 'alarmDeadline') ? data.alarmInRange[i].alarmDeadline : data.alarmInRange[i].doneDeadline %> - <%= nameFollowupflag %> - <%= data.alarmInRange[i].message.headers.subject %>
 		</a>
 	</li>
@@ -18,4 +22,4 @@
 
 <fieldset class="alert-options">
-	<input type="checkbox" name="stopAlert"> <label>Não mostrar essa janela por hoje.</label>
+	<input type="checkbox" name="stopAlert"> <label><%= get_lang("Don't show this window anymore today.")%></label>
 </fieldset>
Index: /trunk/expressoMail1_2/setup/phpgw_pt-br.lang
===================================================================
--- /trunk/expressoMail1_2/setup/phpgw_pt-br.lang	(revision 5703)
+++ /trunk/expressoMail1_2/setup/phpgw_pt-br.lang	(revision 5738)
@@ -780,5 +780,6 @@
 Basic	expressoMail1_2	pt-br	Básico 
 Label name	expressoMail1_2	pt-br	 Nome do marcador 
-Label Color	expressoMail1_2	pt-br	Cor do marcador 
+Label Color	expressoMail1_2	pt-br	Cor do marcador
+New Label	expressoMail1_2	pt-br	Novo Marcador  
 Default	expressoMail1_2	pt-br	Padrão 
 Coala	expressoMail1_2	pt-br	Coala 
@@ -804,2 +805,14 @@
 Done	expressoMail1_2	pt-br	Concluido
 This event does not exist on its agenda	expressoMail1_2	pt-br	Este evento não existe em sua agenda.
+Follow up	expressoMail1_2	pt-br	Acompanhar
+Read	expressoMail1_2	pt-br	Ler
+Answer	expressoMail1_2	pt-br	Responder
+Forward	expressoMail1_2	pt-br	Encaminhar
+Don't forward	expressoMail1_2	pt-br	Não Encaminhar
+Don't answer	expressoMail1_2	pt-br	Não Responder
+Show All Items	expressoMail1_2	pt-br	Mostrar Todos os Itens
+You have one undone message today:	expressoMail1_2	pt-br	Você tem uma mensagem concluindo hoje: 
+You have a follow up due for today:	expressoMail1_2	pt-br	Você tem uma mensagem sinalizada para hoje:	
+You have %1 undone messages today:	expressoMail1_2	pt-br	Você tem %1 mensagens concluindo hoje:
+You have %1 follow ups due for today:	expressoMail1_2	pt-br	Você tem %1 mensagens sinalizadas para hoje:
+Don't show this window anymore today.	expressoMail1_2	pt-br	Não mostrar essa janela por hoje.
Index: /trunk/expressoMail1_2/js/common_functions.js
===================================================================
--- /trunk/expressoMail1_2/js/common_functions.js	(revision 5713)
+++ /trunk/expressoMail1_2/js/common_functions.js	(revision 5738)
@@ -720,4 +720,5 @@
 		messages: messages
 	};
+	console.log(data);
 	dialogElement = $('.followupflag-configure-win').html(DataLayer.render("../prototype/modules/mail/templates/followupflag_configure.ejs", data))
 
Index: /trunk/expressoMail1_2/js/search.js
===================================================================
--- /trunk/expressoMail1_2/js/search.js	(revision 5725)
+++ /trunk/expressoMail1_2/js/search.js	(revision 5738)
@@ -564,7 +564,7 @@
 						if(current_folder == mailbox){
 							$('#td_message_followup_' + messageClickedId + ', ' + 
-							'tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited").css("background", aux.followupflagged.backgroundColor).attr('title', 'Follow up');	
+							'tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited").css("background", aux.followupflagged.backgroundColor).attr('title', get_lang('Follow up'));	
 						}else{
-							$('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited").css("background", aux.followupflagged.backgroundColor).attr('title', 'Follow up');		
+							$('tr[role="'+messageClickedId+'_'+mailbox+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited").css("background", aux.followupflagged.backgroundColor).attr('title', get_lang('Follow up'));		
 						}					
 						aux.followupflagged.id = DataLayer.put('followupflagged', aux.followupflagged);
@@ -745,5 +745,10 @@
 				//Carregar os followupflag nos resultados.
 				if (aux.followupflagged) {
-					$(td).attr('title', aux.followupflagged.followupflag.name)
+					if(aux.followupflagged.followupflag.id < 7){
+						var nameFollowupflag = get_lang(aux.followupflagged.followupflag.name);
+					}else{
+						var nameFollowupflag = aux.followupflagged.followupflag.name;
+					}
+					$(td).attr('title', nameFollowupflag)
 					.find(".flag-edited").css("background",aux.followupflagged.backgroundColor);
 					if(aux.followupflagged.isDone == "1"){
Index: /trunk/expressoMail1_2/js/draw_api.js
===================================================================
--- /trunk/expressoMail1_2/js/draw_api.js	(revision 5735)
+++ /trunk/expressoMail1_2/js/draw_api.js	(revision 5738)
@@ -1664,5 +1664,10 @@
 	
 		if (headers_msgs.followupflagged) {
-			$(td_element26).attr('title', headers_msgs.followupflagged.followupflag.name)
+			if(headers_msgs.followupflagged.followupflag.id < 7){
+				var nameFollowupflag = get_lang(headers_msgs.followupflagged.followupflag.name);
+			}else{
+				var nameFollowupflag = headers_msgs.followupflagged.followupflag.name;
+			}
+			$(td_element26).attr('title', nameFollowupflag)
 			.find(".flag-edited").css("background",headers_msgs.followupflagged.backgroundColor);
 			if(headers_msgs.followupflagged.isDone == "1"){
@@ -1710,5 +1715,5 @@
 				};
 				$('#td_message_followup_' + messageClickedId + ', ' + 
-				'tr[role="'+messageClickedId+'_'+msg_folder+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited").css("background", headers_msgs.followupflagged.backgroundColor).attr('title', 'Follow up');
+				'tr[role="'+messageClickedId+'_'+msg_folder+'"] #td_message_followup_search_' + messageClickedId).find(".flag-edited").css("background", headers_msgs.followupflagged.backgroundColor).attr('title', get_lang('Follow up'));
 				headers_msgs.followupflagged.id = DataLayer.put('followupflagged', headers_msgs.followupflagged);
 				DataLayer.commit(false, false, function(){
Index: /trunk/expressoMail1_2/js/doiMenuData.js
===================================================================
--- /trunk/expressoMail1_2/js/doiMenuData.js	(revision 5688)
+++ /trunk/expressoMail1_2/js/doiMenuData.js	(revision 5738)
@@ -85,5 +85,5 @@
 	var menuLabelItems = {};
 		menuLabelItems["new"] = {
-			"name" : 'Novo Marcador',
+			"name" : get_lang('New Label'),
 			callback:function() {configureLabels({applyToSelectedMessages:true});}
 		};