Index: trunk/prototype/modules/attach_message/attach_message.css
===================================================================
--- trunk/prototype/modules/attach_message/attach_message.css	(revision 5519)
+++ trunk/prototype/modules/attach_message/attach_message.css	(revision 5749)
@@ -46,10 +46,13 @@
 */
 .recent {background-image:url(images/.png);}
-.unseen {background-image:url(images/.png);}
-.seen {background-image:url(images/.png);}
-.answered {background-image:url(images/.png);}
-.draft {background-image:url(images/.png);}
+.unseen {background-image:url(images/unseen.gif); background-repeat: no-repeat;}
+.seen {background-image:url(images/seen.gif); background-repeat: no-repeat;}
+.answered {background-image:url(images/answered.gif); background-repeat: no-repeat; position:relative; top:3px; left:3px;}
+.forwarded {background-image:url(images/forwarded.gif); background-repeat: no-repeat; position:relative; top:3px; left:3px;}
+.draft {background-image:url(images/draft.gif); background-repeat: no-repeat; position:relative; top:3px; left:3px;}
+.labeled{background-image:url(images/tag.png); background-repeat: no-repeat; position:relative; top:3px; left:3px;}
+.followupflagged{width:8px;height:6px;}
 .deleted { }
-.flagged { }
+.Flagged {background-image:url(images/important.png); background-repeat: no-repeat;}
 
 #loading-content .image {width: 32px; height: 32px; background-image: url(images/loading.gif);}
Index: trunk/prototype/modules/attach_message/attach_message.js
===================================================================
--- trunk/prototype/modules/attach_message/attach_message.js	(revision 5533)
+++ trunk/prototype/modules/attach_message/attach_message.js	(revision 5749)
@@ -5,5 +5,5 @@
 dots = /\./gi;
 dashes = /\//gi;
-flags = [ 'Recent', 'Unseen',  'Answered',  'Draft',  'Deleted', 'Flagged' ];
+flags = [ 'Attachment', 'Forwarded' ,'Recent', 'Unseen',  'Answered',  'Draft',  'Deleted', 'Flagged', 'Followupflag', 'Label' ];
 
 $.ajaxPrefilter(function( options, originalOptions, jqXHR ){
@@ -104,16 +104,26 @@
 
 flags2Class = function(cellvalue, options, rowObject) {
-	var classes = '';
+	var classes = '';	
+	cellvalue = cellvalue.split(',');
+	cell = {
+			Unseen: parseInt(cellvalue[0])  ? 'Unseen' : 'Seen', 
+			Answered: parseInt(cellvalue[1]) ? 'Answered' : (parseInt(cellvalue[2]) ? 'Forwarded' : ''), 
+			Flagged: parseInt(cellvalue[3]) ? 'Flagged' : '',
+			Recent: parseInt(cellvalue[4])  ? 'Recent' : '', 			
+			Draft: parseInt(cellvalue[5]) ? 'Draft' : ''		
+		};
+	for(var flag in cell){
+		classes += '<span class="flags '+ (cell[flag]) +'" title="'+ (cell[flag]) +'"> </span>';	
+	}
 	
-	if(cellvalue ==""){
-		classes += '<span class="flags seen" title="seen"> </span>';
-		return classes;
-	}
-	var flags_enum = cellvalue.split(',');
+	if(rowObject.labels){		
+		classes += '<span class="flags labeled"> </span>';
+	}else{
+		classes += '<span class="flags"> </span>';
+	}
 	
-	for (var i=0; i<flags_enum.length; i++){
-		classes += '<span class="flags '+flags_enum[i].toLowerCase()+'" title="'+flags_enum[i].toLowerCase()+'"> </span>';
-	}
-	
+	if(rowObject.followupflagged){		
+		classes += '<span class="flags followupflagged" style="background:'+rowObject.followupflagged.backgroundColor+';"><img src="../prototype/modules/mail/img/flagEditor.png"></span>';
+	}
 	return classes;
 }
@@ -149,7 +159,8 @@
 
 NormaliseFrom = function(cellvalue, options, rowObject) {
-	//alert(dump(rowObject));
-	if(rowObject['flags'].indexOf("Draft") >=  0)
+	rowObject['flags'] = rowObject['flags'].split(",");
+	if(rowObject['flags'][rowObject['flags'].length-1] ==  1){
 		return get_lang(special_folders["Drafts"]);
+	}
 	return cellvalue;	
 }
@@ -322,6 +333,6 @@
 			colModel:[
 				{name:'msg_number',index:'msg_number', width:45, hidden:true, sortable:false},
-				{name:'flags',index:'msg_number',edittype: 'image', width:40, sortable:false, formatter:flags2Class},
-				{name:'from.name',index:'msg_number', width:130, sortable:false, formatter:NormaliseFrom},
+				{name:'flags',index:'msg_number',edittype: 'image', width:100, sortable:false, formatter:flags2Class},
+				{name:'from.name',index:'msg_number', width:70, sortable:false, formatter:NormaliseFrom},
 				{name:'subject',index:'subject', width:245, sortable:false},
 				{name:'timestamp',index:'timestamp', width:65, align:"center", sortable:false, formatter:date2Time},